
\begin{tt}
\begin{verbatim}

module declac_eg1a.

%  Illustrates use of magic fact in conjunction with no_rewriting

export anc(bf).

@no_rewriting.  	% No program transformation is done...

                %  ...so this rule must be added to define anc_bf
anc_bf(X,Y) :- anc(X,Y).

anc(X,Y) :- m_anc_bf(X), 	% The fact m_anc_bf(5) is automatically  
	    parent(X,Y).  	% added when computing answers to 
				% ?anc(5,X); this rule takes advantage
				% of this fact.

anc(X,Y) :- anc(X,Z), parent(Z,Y). 

end_module.


\end{verbatim}
\end{tt}
