

\begin{tt}
\begin{verbatim}

module declse_eg2.

export okteam(f), team(f), engineer(f), pilot(f), doctor(f).

engineer(joe).
engineer(jack).
pilot(amy).
pilot(jack).
doctor(jack).
doctor(paula).

team({jack}).
team({amy,joe}).
team({amy,joe,paula}).
team({amy,joe,paula,jack}).

% An okteam must contain a doctor, a pilot and an engineer.
% They need not be different people; however, the size of the
% team must be at most 3.
 
okteam(S) :- team(S), count(S,C), C <= 3, member(S,X), member(S,Y),
			member(S,Z), engineer(X), pilot(Y), doctor(Z). 

end_module.

\end{verbatim}
\end{tt}
